﻿using UnityEngine;

public class PowerDistributor : Mod
{
    public PowerDistributor instance;

    Battery[] batterys;
	public float tickTimer = 1;
    public float updateTimer = 30;
    public int midPoint = 25;

    public void Start()
    {
        instance = this;
        Refresh();
        Debug.Log("Mod PowerDistributor has been loaded!");
    }

    public void OnModUnload()
    {
        Debug.Log("Mod PowerDistributor has been unloaded");
    }
	
	public override void WorldEvent_WorldLoaded()
	{
        Refresh();
        updateTimer = 30;
    }
	
	public override void WorldEvent_WorldSaved()
	{
        Refresh();
        updateTimer = 30;
    }

    //[ConsoleCommand(name: "Batnet", docs: "add all batterys to the net")]
    //public static void Batnet()
    //{
    //    instance.Refresh();
    //}

    //public void Batmax()
    //{
    //    if (Semih_Network.IsHost)
    //    {
    //        Refresh();
    //        foreach (Battery v in batterys) //pull power
    //        {
    //            if (v != null && v.BatterySlotIsEmpty == false)
    //            {
    //                v.AddBatteryUsesNetworked(50 - v.BatteryUses);
    //            }
    //        }
    //        Debug.Log("All batterys are filled");
    //    }
    //}

    //public void Batmin()
    //{
    //    if (Semih_Network.IsHost)
    //    {
    //        Refresh();
    //        foreach (Battery v in batterys) //pull power
    //        {
    //            if (v != null && v.BatterySlotIsEmpty == false)
    //            {
    //                v.RemoveBatteryUsesNetworked(v.BatteryUses);
    //            }
    //        }
    //        Debug.Log("All batterys are empty");
    //    }
    //}

    public void Refresh()
    {
        if (Semih_Network.IsHost)
        {
            batterys = FindObjectsOfType<Battery>();
            Debug.Log("All batterys are added");
        }
    }

    void Update()
    {
        updateTimer -= Time.deltaTime;
        if (updateTimer <= 0)
        {
            updateTimer = 30;
            Refresh();
        }

        if (Semih_Network.IsHost)
        {
            tickTimer -= Time.deltaTime;
            if (tickTimer <= 0)
            {
                tickTimer = 0.2f;
                Sift();

                //ShowBatterys();
            }
        }
	}

    void Sift()
    {
        int maxIndex = -1;
        int maxValue = midPoint;
        int minIndex = -1;
        int minValue = midPoint;
        for (int i = 0; i < batterys.Length; i++)
        {
            if (batterys[i] != null && batterys[i].BatterySlotIsEmpty == false)
            {
                int b = batterys[i].BatteryUses;
                if (b > maxValue) { maxValue = b; maxIndex = i; }
                if (b < minValue) { minValue = b; minIndex = i; }
            }
        }
        if (maxValue > midPoint && minValue < midPoint)
        {
            batterys[maxIndex].RemoveBatteryUsesNetworked(1);
            batterys[minIndex].AddBatteryUsesNetworked(1);
        }
    }

    void ShowBatterys()
    {
        int i = 0;
        foreach (Battery v in batterys)
        {
            i++;
            if (v != null)
            {
                string res1 = new string('=', v.BatteryUses);
                string res2 = new string('+', 50-v.BatteryUses);
                Debug.Log(i.ToString("00") + " [" + res1 + res2 + "] (" + v.BatteryUses.ToString("00") + "/50) " + !v.BatterySlotIsEmpty);

            }
        }
    }
	
}